package org.java.evolutionary.sequence;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.LinkedList;
import java.util.List;

public class FileUtil {
	static BufferedWriter writer = null;
	
	static{
		try{
			writer = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream("Elites.txt", true))); 
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static synchronized void quickWrite(String data) throws Exception {
		writer.write(data);
	}
	
	public static void close() throws Exception {
		writer.flush();
		writer.close();
	}

/**
	 * Writes a string into a text file.
	 * 
	 * @param f
	 *            the file to be written
	 * @param text
	 *            the string to write
	 * @param append
	 *            <code>true</code> to append to an existing file
	 * @param utf8
	 *            writes the text to an UTF8 encoded file
	 * @exception java.io.IOException
	 */
	public static void writeStringToTextFile(File f, String text, boolean append)
			throws IOException {
		if (f.getParentFile() != null) {
			f.getParentFile().mkdirs();
		}

		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(f.getAbsolutePath(), append)));

			if (text == null) {
				writer.write("");
			} else {
				writer.write(text);
			}
		} finally {
			if (writer != null) {
				writer.close();
			}
		}
	}
	

	/**
	 * Reads the lines of a text file.
	 * 
	 * @param f
	 *            the file to be read
	 * @param trimWhiteSpace
	 *            if <code>true</code> , all white space in front and at the
	 *            end of a line will be romved, new line characters inclusive.
	 * @param utf8
	 *            reads from an UTF8 encoded file
	 * @return a list of strings, one for each line
	 * @exception java.io.IOException
	 */
	public static List readTextFileToStringList(File f, boolean trimWhiteSpace)
			throws IOException {
		List result = new LinkedList();
		BufferedReader reader = null;
		try {

			reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(f)));

			String line = reader.readLine();
			while (line != null) {
				if (trimWhiteSpace) {
					line = line.trim();
				}

				result.add(line);

				line = reader.readLine();
			}
		} finally {
			if (reader != null) {
				reader.close();
			}
		}

		return result;
	}
}
