package org.java.evolutionary.sequence.func;

import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;

public class DNode extends GPNode{
	char term = 'd';
	public String toString() { return Character.toString(term); } 
	
	public void checkConstraints(final EvolutionState state, final int tree, 
								 final GPIndividual typicalIndividual, 
								 final Parameter individualBase)
	{
		super.checkConstraints(state, tree, typicalIndividual, individualBase); 
		if (children.length!=0) 
			state.output.error("Incorrect number of children for node " + 
							   toStringForError() + " at " + 
							   individualBase); 
	}
	
	public void eval(final EvolutionState state, 
					 final int thread,
					 final GPData input, 
					 final ADFStack stack, 
					 final GPIndividual individual,
					 final Problem problem) 
	{
		MotifData motifData = ((MotifData) (input));
		motifData.currentTerminal =term;
	}
	

}
