package org.java.evolutionary.sequence.func;


import ec.EvolutionState;
import ec.Problem;
import org.java.evolutionary.sequence.MotifData;
import ec.gp.ADFStack;
import ec.gp.GPData;
import ec.gp.GPIndividual;
import ec.gp.GPNode;
import ec.util.Parameter;
/**
 * This generates a random Node of 8 Terminals of any combinations of {A,C,T,G} Terminal nodes.
 * @author udaykamath
 *
 */
public class StringNodeSize8 extends GPNode{
	public String toString(){
		return " motif8";
	}
	public void checkConstraints(final EvolutionState state, final int tree,
			final GPIndividual typicalIndividual, final Parameter individualBase) {
		super.checkConstraints(state, tree, typicalIndividual, individualBase);
		if (children.length != 8)
			state.output.error("Incorrect number of children for node "
					+ toStringForError() + " at " + individualBase);
	}

	public void eval(final EvolutionState state, final int thread,
			final GPData input, final ADFStack stack,
			final GPIndividual individual, final Problem problem) {
		int position;
		MotifData motifData = ((MotifData) (input));
		char[] x = new char[8];
		children[0].eval(state, thread, input, stack, individual, problem);
		x[0] = motifData.currentTerminal;
		children[1].eval(state, thread, input, stack, individual, problem);
		x[1] = motifData.currentTerminal;
		children[2].eval(state, thread, input, stack, individual, problem);
		x[2] = motifData.currentTerminal;
		children[3].eval(state, thread, input, stack, individual, problem);
		x[3] = motifData.currentTerminal;
		children[4].eval(state, thread, input, stack, individual, problem);
		x[4] = motifData.currentTerminal;
		children[5].eval(state, thread, input, stack, individual, problem);
		x[5] = motifData.currentTerminal;
		children[6].eval(state, thread, input, stack, individual, problem);
		x[6] = motifData.currentTerminal;
		children[7].eval(state, thread, input, stack, individual, problem);
		x[7] = motifData.currentTerminal;
		motifData.currentMotif = x;
	}

}
